// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UK2Node.h"
#include "ISCW_UK2Node_Event.h"
#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UK2Node_ComponentBoundEvent : public virtual ISCW_UK2Node_Event
	{
	public:
		virtual ~ISCW_UK2Node_ComponentBoundEvent() = default;

		virtual shared_ptr<ISCW_UK2Node> AsUK2Node() const = 0;

		virtual shared_ptr<ISCW_UK2Node_Event> AsUK2Node_Event() const = 0;
		
		virtual wstring GetDelegatePropertyName() const = 0;

		virtual wstring GetComponentPropertyName() const = 0;
	};

	using ISCW_UK2Node_ComponentBoundEventConstPtr = shared_ptr<const ISCW_UK2Node_ComponentBoundEvent>;
	using ISCW_UK2Node_ComponentBoundEventPtr = shared_ptr<ISCW_UK2Node_ComponentBoundEvent>;
} // namespace Sourcify